#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum MagnitudeAndPhaseDisplayMode {
    #[serde(rename = "MAGNITUDE")]
    Magnitude,
    #[serde(rename = "PHASE")]
    Phase,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl MagnitudeAndPhaseDisplayMode {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            MagnitudeAndPhaseDisplayMode::Magnitude => "MAGNITUDE",
            MagnitudeAndPhaseDisplayMode::Phase => "PHASE",
            MagnitudeAndPhaseDisplayMode::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for MagnitudeAndPhaseDisplayMode {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for MagnitudeAndPhaseDisplayMode {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for MagnitudeAndPhaseDisplayMode {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<MagnitudeAndPhaseDisplayMode, conjure_object::plain::ParseEnumError> {
        match v {
            "MAGNITUDE" => Ok(MagnitudeAndPhaseDisplayMode::Magnitude),
            "PHASE" => Ok(MagnitudeAndPhaseDisplayMode::Phase),
            v => v.parse().map(|v| MagnitudeAndPhaseDisplayMode::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for MagnitudeAndPhaseDisplayMode {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<MagnitudeAndPhaseDisplayMode, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the MagnitudeAndPhaseDisplayMode enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
